package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrXinyonghuaihuaBaseInfo;
import com.zksy.data.domain.response.XcrXinyonghuaihuaBaseInfoResponse;
import com.zksy.data.mapper.XcrXinyonghuaihuaBaseInfoMapper;
import com.zksy.data.service.XcrXinyonghuaihuaBaseInfoService;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

/**
* @author Administrator
* @description 针对表【xcr_xinyonghuaihua_base_info(信用怀化基础数据)】的数据库操作Service实现
* @createDate 2024-10-14 11:12:59
*/
@Service
@Slf4j
public class XcrXinyonghuaihuaBaseInfoServiceImpl extends ServiceImpl<XcrXinyonghuaihuaBaseInfoMapper, XcrXinyonghuaihuaBaseInfo>
    implements XcrXinyonghuaihuaBaseInfoService{
    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Override
    @Transactional(rollbackFor = Exception.class)
    @XhDataLogRecord("同步信用怀化基础信息")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrXinyonghuaihuaBaseInfo> toDatabaseList = new Vector<>();
        List<String> inventoryList = List.of("20", "21","22","23","24");
        inventoryList.parallelStream().forEach(inventory -> {
            creditCodes.parallelStream().forEach(creditCode -> {
                HashMap<String, String> requestbodyMap = new HashMap<>();
                requestbodyMap.put("entityCode", creditCode);
                requestbodyMap.put("size", String.valueOf(10));
                requestbodyMap.put("page", String.valueOf(1));
                requestbodyMap.put("inventoryId", inventory);
                try {
                    List<XcrXinyonghuaihuaBaseInfo> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrXinyonghuaihuaBaseInfoResponse.class,
                            XcrXinyonghuaihuaBaseInfo.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                } catch (Exception e) {
                    List<XcrXinyonghuaihuaBaseInfo> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrXinyonghuaihuaBaseInfoResponse.class,
                            XcrXinyonghuaihuaBaseInfo.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                }
            });
            log.info("inventorywe为:{}完成",inventory);
        });
        this.remove(null);
        this.saveBatch(toDatabaseList);
        log.info("信用怀化基础信息同步完成");
    }
}




